/*
    ShapeTemplateCmd.cc - fucntion plotter for templates

    Will 18, 2001: will@opaline.demon.co.uk
  
    due to design cockup, maintaining spatial data in a separate pak means a
    copy of this just for pak templates...
*/

#include "Application.h"
#include <DMenuCmd.h>
#include "OpResources.h"
#include "ShapeTemplateCmd.h"
#include "AppWindow.h"
#include <MessageDialogManager.h>
#include <InfoDialogManager.h>
#include <Xm/Label.h>
#include <Xm/Form.h>
#include <Xm/RowColumn.h>
#include <Xm/Protocols.h>
#include <Xm/TextF.h>
#include <Xm/PushB.h>
#include <Xm/Separator.h>
#include <GraphIntCmd.h>
#include <GraphFltCmd.h>
#include "MixwaveUtils.h"
#include <math.h>
#include "DataConformCmd.h"


ShapeTemplateCmd::ShapeTemplateCmd ( char *name, int active, unsigned int numDigits, unsigned int fpDigits ) : NoUndoCmd ( name, active )
{
	_numDigits = numDigits;	// use resources, cut from constr?
	_fpDigits = fpDigits;
	_name = name;
	_shapeTemplateRealised = False;
	_templateRealised = False;
	_selectedItemNum = 0;
	_dataOffset = 0;
}


void ShapeTemplateCmd::doCommand()
{
	if ( _shapeTemplateRealised == True )
		return;
	else
		_shapeTemplateRealised = True;
		
	int n;
	Arg args[5];
	Atom WM_DELETE_WINDOW;

	_popup = XtCreatePopupShell ( _name, transientShellWidgetClass,
									application->baseWidget(), NULL, 0 );

	_form = XtCreateManagedWidget ( "Form", xmFormWidgetClass, _popup,
										NULL, 0 );

	_templateSel = XtVaCreateManagedWidget ( "Template", xmPushButtonWidgetClass, _form,
												XmNtopAttachment, XmATTACH_FORM,
												XmNleftAttachment, XmATTACH_FORM,
												NULL );

	_label = XtVaCreateManagedWidget ( "none", xmLabelWidgetClass, _form, 
						XmNtopAttachment, XmATTACH_FORM,
						XmNleftAttachment, XmATTACH_WIDGET,
						XmNleftWidget, _templateSel,
						NULL );

	_sep = XtVaCreateManagedWidget ( "sep", xmSeparatorWidgetClass, _form,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _templateSel,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNseparatorType, XmSHADOW_ETCHED_IN,
						NULL );
										
	_rc1 = XtVaCreateManagedWidget ( "RowColumn1", xmRowColumnWidgetClass, _form,
										XmNorientation, XmHORIZONTAL,
						XmNnumColumns, 1,
						XmNpacking, XmPACK_COLUMN,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _sep,
						NULL );

	_rc2 = XtVaCreateManagedWidget ( "RowColumn2", xmRowColumnWidgetClass, _form,
						XmNorientation, XmHORIZONTAL,
						XmNnumColumns, 1,
						XmNpacking, XmPACK_COLUMN,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _rc1,
						NULL );

	_rc3 = XtVaCreateManagedWidget ( "RowColumn3", xmRowColumnWidgetClass, _form,
						XmNorientation, XmHORIZONTAL,
						XmNnumColumns, 1,
						XmNpacking, XmPACK_COLUMN,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _rc2,
										NULL );

	_rc4 = XtVaCreateManagedWidget ( "RowColumn4", xmRowColumnWidgetClass, _form,
						XmNorientation, XmHORIZONTAL,
						XmNnumColumns, 1,
						XmNpacking, XmPACK_COLUMN,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _rc3,
						NULL );

	_rc5 = XtVaCreateManagedWidget ( "RowColumn5", xmRowColumnWidgetClass, _form,
						XmNorientation, XmHORIZONTAL,
						XmNnumColumns, 1,
						XmNpacking, XmPACK_COLUMN,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _rc4,
						NULL );

	_rc6 = XtVaCreateManagedWidget ( "RowColumn6", xmRowColumnWidgetClass, _form,
						XmNorientation, XmHORIZONTAL,
						XmNnumColumns, 1,
						XmNpacking, XmPACK_COLUMN,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _rc5,
						NULL );

	n = 0;

	XtSetArg ( args[n], XmNcolumns, _numDigits ); n++;
	XtSetArg ( args[n], XmNeditable, TRUE ); n++;
	XtSetArg ( args[n], XmNcursorPositionVisible, TRUE ); n++;
	XtSetArg ( args[n], XmNmaxLength, _numDigits+_fpDigits ); n++;

	_funct1 = XtCreateManagedWidget ( "Line", xmPushButtonWidgetClass,_rc1, NULL, 0 );
	_label1a = XtCreateManagedWidget ( "Initial", xmLabelWidgetClass, _rc1, NULL, 0 );
	_field1a = XtCreateManagedWidget ( "field1a", xmTextFieldWidgetClass, _rc1, args, n );
	_label1b = XtCreateManagedWidget ( "Final", xmLabelWidgetClass, _rc1, NULL, 0 );
	_field1b = XtCreateManagedWidget ( "field1b", xmTextFieldWidgetClass, _rc1, args, n );

	XtAddCallback ( _funct1, XmNactivateCallback, &ShapeTemplateCmd::funct1Callback, ( XtPointer ) this );
	XtAddCallback ( _field1a, XmNactivateCallback, &ShapeTemplateCmd::field1aEntryCallback, ( XtPointer ) this );
	XtAddCallback ( _field1b, XmNactivateCallback, &ShapeTemplateCmd::field1bEntryCallback, ( XtPointer ) this );

	_funct2 = XtCreateManagedWidget ( "Sine", xmPushButtonWidgetClass,_rc2, NULL, 0 );
	_label2a = XtCreateManagedWidget ( "Repeats", xmLabelWidgetClass, _rc2, NULL, 0 );
	_field2a = XtCreateManagedWidget ( "field2a", xmTextFieldWidgetClass, _rc2, args, n );
	_label2b = XtCreateManagedWidget ( "Offset", xmLabelWidgetClass, _rc2, NULL, 0 );
	_field2b = XtCreateManagedWidget ( "field2b", xmTextFieldWidgetClass, _rc2, args, n );

	XtAddCallback ( _funct2, XmNactivateCallback, &ShapeTemplateCmd::funct2Callback, ( XtPointer ) this );
	XtAddCallback ( _field2a, XmNactivateCallback, &ShapeTemplateCmd::field2aEntryCallback, ( XtPointer ) this );
	XtAddCallback ( _field2b, XmNactivateCallback, &ShapeTemplateCmd::field2bEntryCallback, ( XtPointer ) this );

	_funct3 = XtCreateManagedWidget ( "Tan", xmPushButtonWidgetClass,_rc3, NULL, 0 );
	_label3a = XtCreateManagedWidget ( "Initial", xmLabelWidgetClass, _rc3, NULL, 0 );
	_field3a = XtCreateManagedWidget ( "field3a", xmTextFieldWidgetClass, _rc3, args, n );
	_label3b = XtCreateManagedWidget ( "Final", xmLabelWidgetClass, _rc3, NULL, 0 );
	_field3b = XtCreateManagedWidget ( "field3b", xmTextFieldWidgetClass, _rc3, args, n );

	XtAddCallback ( _funct3, XmNactivateCallback, &ShapeTemplateCmd::funct3Callback, ( XtPointer ) this );
	XtAddCallback ( _field3a, XmNactivateCallback, &ShapeTemplateCmd::field3aEntryCallback, ( XtPointer ) this );
	XtAddCallback ( _field3b, XmNactivateCallback, &ShapeTemplateCmd::field3bEntryCallback, ( XtPointer ) this );

	_funct4 = XtCreateManagedWidget ( "Exp", xmPushButtonWidgetClass,_rc4, NULL, 0 );
	_label4a = XtCreateManagedWidget ( "Initial", xmLabelWidgetClass, _rc4, NULL, 0 );
	_field4a = XtCreateManagedWidget ( "field4a", xmTextFieldWidgetClass, _rc4, args, n );
	_label4b = XtCreateManagedWidget ( "Final", xmLabelWidgetClass, _rc4, NULL, 0 );
	_field4b = XtCreateManagedWidget ( "field4b", xmTextFieldWidgetClass, _rc4, args, n );

	XtAddCallback ( _funct4, XmNactivateCallback, &ShapeTemplateCmd::funct4Callback, ( XtPointer ) this );
	XtAddCallback ( _field4a, XmNactivateCallback, &ShapeTemplateCmd::field4aEntryCallback, ( XtPointer ) this );
	XtAddCallback ( _field4b, XmNactivateCallback, &ShapeTemplateCmd::field4bEntryCallback, ( XtPointer ) this );

	_funct5 = XtCreateManagedWidget ( "Log", xmPushButtonWidgetClass,_rc5, NULL, 0 );
	_label5a = XtCreateManagedWidget ( "Initial", xmLabelWidgetClass, _rc5, NULL, 0 );
	_field5a = XtCreateManagedWidget ( "field5a", xmTextFieldWidgetClass, _rc5, args, n );
	_label5b = XtCreateManagedWidget ( "Final", xmLabelWidgetClass, _rc5, NULL, 0 );
	_field5b = XtCreateManagedWidget ( "field5b", xmTextFieldWidgetClass, _rc5, args, n );

	XtAddCallback ( _funct5, XmNactivateCallback, &ShapeTemplateCmd::funct5Callback, ( XtPointer ) this );
	XtAddCallback ( _field5a, XmNactivateCallback, &ShapeTemplateCmd::field5aEntryCallback, ( XtPointer ) this );
	XtAddCallback ( _field5b, XmNactivateCallback, &ShapeTemplateCmd::field5bEntryCallback, ( XtPointer ) this );

	_funct6 = XtCreateManagedWidget ( "Smooth", xmPushButtonWidgetClass,_rc6, NULL, 0 );
	_label6a = XtCreateManagedWidget ( "Points", xmLabelWidgetClass, _rc6, NULL, 0 );
	_field6a = XtCreateManagedWidget ( "field6a", xmTextFieldWidgetClass, _rc6, args, n );
	_label6b = XtCreateManagedWidget ( "Weighting", xmLabelWidgetClass, _rc6, NULL, 0 );
	_field6b = XtCreateManagedWidget ( "field6b", xmTextFieldWidgetClass, _rc6, args, n );

	XtAddCallback ( _funct6, XmNactivateCallback, &ShapeTemplateCmd::funct6Callback, ( XtPointer ) this );
	XtAddCallback ( _field6a, XmNactivateCallback, &ShapeTemplateCmd::field6aEntryCallback, ( XtPointer ) this );
	XtAddCallback ( _field6b, XmNactivateCallback, &ShapeTemplateCmd::field6bEntryCallback, ( XtPointer ) this );

	XtAddCallback ( _templateSel, XmNactivateCallback, &ShapeTemplateCmd::templateSelCallback, ( XtPointer ) this );

	// cater for WM 'X' pressed
	WM_DELETE_WINDOW = XmInternAtom ( XtDisplay ( _popup ), "WM_DELETE_WINDOW", False );
XmAddWMProtocols ( _popup, &WM_DELETE_WINDOW, 1 );
//	XmAddWMProtocolCallback ( _popup, WM_DELETE_WINDOW, clientMessageProc, ( XtPointer ) this );
XmAddWMProtocolCallback ( _popup, WM_DELETE_WINDOW, quitCallback, ( XtPointer ) this );

	changeField1a ( 0 );
	changeField1b ( 0 );
	changeField2a ( 1 );
	changeField2b ( 0 );
	changeField3a ( -1.571 );
	changeField3b ( 1.571 );
	changeField4a ( 0 );
	changeField4b ( 0 );
	changeField5a ( 1 );
	changeField5b ( 1 );
	changeField6a ( 3 );	// min data points for curve fit, 0 for simple interpolation
	changeField6b ( 2 );

	XtPopup ( _popup, ( XtGrabKind ) XtGrabNone );
	XtManageChild ( _popup );
}


void ShapeTemplateCmd::clientMessageProc ( Widget, XtPointer clientData, XmAnyCallbackStruct *cbs )
{
	ShapeTemplateCmd *obj = ( ShapeTemplateCmd * ) clientData;

	if ( obj->clientMessage ( cbs ) )
		return;
}


int ShapeTemplateCmd::clientMessage( XmAnyCallbackStruct *cbs )
{
	if ( cbs->reason == XmCR_PROTOCOLS )
	{
		quit();
		return 0;
	}
	
	return 1;
}

void ShapeTemplateCmd::quitCallback ( Widget w, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd *obj = ( ShapeTemplateCmd * ) clientData;

	obj->quit();
}

void ShapeTemplateCmd::templateSelCallback ( Widget w, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd *obj = ( ShapeTemplateCmd * ) clientData;

	if ( obj->_templateRealised == False )
		obj->templateSel();
}


void ShapeTemplateCmd::templateSel()
{
	if ( templatePak->Count() == 0 )
		return;

	unsigned int n;
	unsigned int maxNameLength = 0;
	
	_templateArrayItems = templatePak->Count();

	for ( n = 0; n < _templateArrayItems; n++ )
		if ( strlen ( (*templatePak)[n].name ) > maxNameLength )
			maxNameLength = strlen ( (*templatePak)[n].name );

	n = 0;
	maxNameLength++;
	
	if ( maxNameLength < 3 )
		maxNameLength = 3;	// accomodate 'quit' at a minimum
		
	_templateArrayItems++;
	
	char strings [ _templateArrayItems ] [ maxNameLength ];

	for ( n = 0; n < ( _templateArrayItems - 1 ); n++ )
		strcpy ( ( char * ) &strings [ n ], (*templatePak)[n].name );

	strcpy ( strings [ n ], "Quit" );

	_templateMenu = new DMenuCmd ( "Template shift/scale menu", TRUE, FALSE,
								&ShapeTemplateCmd::templateMenuSelectionCallback,
								( void * ) this, "Current template files",
								_templateArrayItems, maxNameLength, ( char * ) &strings );

	_templateRealised = True;
	_templateMenu->execute();
}


void ShapeTemplateCmd::templateMenuSelectionCallback ( void *clientData, unsigned int selectedItemNum, char *label )
{
	ShapeTemplateCmd *obj = ( ShapeTemplateCmd * ) clientData;

	if ( strcmp ( label, "Quit" ) == 0 )
	{
		obj->_templateRealised = False;
		delete obj->_templateMenu;
	}
	else
	{
		int count, found;
		
		// scan base list for returned name
		for ( count = 0; count < templatePak->Count(); count++ )
		{
			found = 0;
			
			if ( strcmp ( label, (*templatePak)[count].name ) == 0 )
			{
				obj->templateSelected ( (*templatePak)[count].templateNum );
				found = 1;
				count = templatePak->Count();
			}
		}
		
		if ( !found && mixwaveResources->enableMessagePopups() == True )
		{
			char msg[BUFSIZE];

			snprintf ( msg, sizeof ( msg ), "Error: %s\nFile not loaded.", label );
			msg [ sizeof ( msg ) - 1 ] = 0;
			messageDialogManager->post ( msg );
		}
	}
}


void ShapeTemplateCmd::templateSelected ( unsigned int selectedItemNum )
{
	// is the data available?
// if this is a spatial pak this is invalid, checking the wrong thing
// check for data name
	if ( (*templatePak)[selectedItemNum-1].dataType == 0 )
	{
		if ( (*templatePak)[selectedItemNum-1].graphIntCmd == NULL )
		{
			// print msg showing error condition. 'wave view not realised
			char msg[BUFSIZE];
			
			snprintf ( msg, sizeof ( msg ), "%s\nTemplate view not realised\nUse \
'File/View/Template'.", (*templatePak)[selectedItemNum-1].name );
			msg [ sizeof ( msg ) - 1 ] = 0;
			messageDialogManager->post ( msg );
		}
		else
		{
			_dataType = 0;
			_selectedItemNum = selectedItemNum;
			setTitle ( (*templatePak)[selectedItemNum-1].name );
		}
	}
	else
	{
		if ( (*templatePak)[selectedItemNum-1].graphFltCmd == NULL )
		{
			// print msg showing error condition. 'wave view not realised
			char msg[BUFSIZE];
			snprintf ( msg, sizeof ( msg ), "%s\nTemplate view not realised\nUse \
'File/View/Template'.", (*templatePak)[selectedItemNum-1].name );
			msg [ sizeof ( msg ) - 1 ] = 0;
			messageDialogManager->post ( msg );
  		}
		else
		{
			_dataType = 1;
			_selectedItemNum = selectedItemNum;
			setTitle ( (*templatePak)[selectedItemNum-1].name );
		}
	}
}


void ShapeTemplateCmd::setTitle ( char *title )
{
	MixwaveUtils *utils = new MixwaveUtils;
	char name [ strlen ( title ) + 1 ];
	
	strncpy ( name, utils->fileFromPath ( title ), sizeof ( name ) );
	name [ sizeof ( name ) - 1 ] = 0;
	delete utils;
	
	XmString xmstr = XmStringCreateSimple ( ( char * ) name );
	XtVaSetValues ( _label, XmNlabelString, xmstr, NULL );
	XmStringFree ( xmstr );
}


void ShapeTemplateCmd::quit()
{
	if ( _templateRealised == True )
		delete _templateMenu;

	_shapeTemplateRealised = False;
	_templateRealised = False;
	_selectedItemNum = 0;
	XtDestroyWidget ( _popup );
}


void ShapeTemplateCmd::funct1Callback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd *obj = ( ShapeTemplateCmd * ) clientData;

	char text1[obj->_numDigits+obj->_fpDigits];
	char text2[obj->_numDigits+obj->_fpDigits];
	float value1, value2;

	snprintf ( text1, sizeof ( text1 ), "%s", XmTextFieldGetString ( obj->_field1a ) );
	text1 [ sizeof ( text1 ) - 1 ] = 0;

	if ( strlen ( text1 ) > 0 )
		sscanf ( text1, "%f", &value1 );
	else
	{
		value1 = 0;
		obj->changeField1a ( value1 );
	}
	
	snprintf ( text2, sizeof ( text2 ), "%s", XmTextFieldGetString ( obj->_field1b ) );
	text2 [ sizeof ( text2 ) - 1 ] = 0;

	if ( strlen ( text2 ) > 0 )
		sscanf ( text2, "%f", &value2 );
	else
	{
		value2 = 0;
		obj->changeField1b ( value2 );
	}
	
	obj->funct1 ( value1, value2 );
}


void ShapeTemplateCmd::funct1 ( float start, float end )
{
	if ( _dataType == 0 )
	{
		if ( (*templatePak)[_selectedItemNum-1].graphIntCmd == NULL )
			return;
	}
	else
	{
		if ( (*templatePak)[_selectedItemNum-1].graphFltCmd == NULL )
			return;
	}

	long count;
	float value = start;

	readData();

	// function body
	float increment = ( end - start ) / ( _endData - _startData );

	for ( count = _startData; count <= _endData; count ++ )
	{
		if ( _dataType == 0 )	// int
			_idata [ count - _dataOffset ] = ( int ) ( value + 0.5 );
		else
			_fdata [ count - _dataOffset ] = value;

		value += increment;
	}

	writeData();
}


void ShapeTemplateCmd::field1aEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd* obj = ( ShapeTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field1a ) );
	text [ sizeof ( text ) - 1 ] = 0;
	
	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field1aEntry ( text );
}


void ShapeTemplateCmd::field1bEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd* obj = ( ShapeTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field1b ) );
	text [ sizeof ( text ) - 1 ] = 0;

	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field1bEntry ( text );
}


void ShapeTemplateCmd::field1aEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField1a ( value );
	}
	else
		changeField1a ( 0 );
}


void ShapeTemplateCmd::field1bEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField1b ( value );
	}
	else
		changeField1b ( 1 );
}


void ShapeTemplateCmd::changeField1a ( float value )
{
	char text[ _numDigits + _fpDigits + 1 ];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );
	XmTextFieldSetString ( _field1a, text );
}


void ShapeTemplateCmd::changeField1b ( float value )
{
	char text[ _numDigits + _fpDigits + 1];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );

	XmTextFieldSetString ( _field1b, text );
}


void ShapeTemplateCmd::funct2Callback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd *obj = ( ShapeTemplateCmd * ) clientData;

	char text1[obj->_numDigits+obj->_fpDigits];
	char text2[obj->_numDigits+obj->_fpDigits];
	float value1, value2;

	snprintf ( text1, sizeof ( text1 ), "%s", XmTextFieldGetString ( obj->_field2a ) );
	text1 [ sizeof ( text1 ) - 1 ] = 0;

	if ( strlen ( text1 ) > 0 )
		sscanf ( text1, "%f", &value1 );
	else
	{
		value1 = 1;
		obj->changeField2a ( value1 );
	}
	
	snprintf ( text2, sizeof ( text2 ), "%s", XmTextFieldGetString ( obj->_field2b ) );
	text2 [ sizeof ( text2 ) - 1 ] = 0;

	if ( strlen ( text2 ) > 0 )
		sscanf ( text2, "%f", &value2 );
	else
	{
		value2 = 0;
		obj->changeField2b ( value2 );
	}
	
	obj->funct2 ( value1, value2 );
}


void ShapeTemplateCmd::funct2 ( float repeats, float offset )
{
	if ( _dataType == 0 )
	{
		if ( (*templatePak)[_selectedItemNum-1].graphIntCmd == NULL )
			return;
	}
	else
	{
		if ( (*templatePak)[_selectedItemNum-1].graphFltCmd == NULL )
			return;
	}

	
	if ( repeats == 0 )
	{
		changeField2a ( 1 );
		return;
	}

	long count;
	float value, scale, increment;

	readData();

	// function body
	increment = ( repeats / ( _endData - _startData ) ) * 2 * 3.141592654;
	value = offset;
	scale = (*templatePak)[_selectedItemNum-1].max;
	
	for ( count = _startData; count <= _endData; count ++ )
	{
		if ( _dataType == 0 )	// int
		{
			_idata [ count - _dataOffset ] = ( int ) ( sin ( value ) * scale );
			value += increment;
		}
		else
		{
			_fdata [ count - _dataOffset ] = sin ( value ) * scale;
			value += increment;
		}
	}

	writeData();
}


void ShapeTemplateCmd::field2aEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd* obj = ( ShapeTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field2a ) );
	text [ sizeof ( text ) - 1 ] = 0;
	
	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "1", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field2aEntry ( text );
}


void ShapeTemplateCmd::field2bEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd* obj = ( ShapeTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field2b ) );
	text [ sizeof ( text ) - 1 ] = 0;

	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field2bEntry ( text );
}


void ShapeTemplateCmd::field2aEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField2a ( value );
	}
	else
		changeField2a ( 1 );
}


void ShapeTemplateCmd::field2bEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField2b ( value );
	}
	else
		changeField2b ( 0 );
}


void ShapeTemplateCmd::changeField2a ( float value )
{
	char text[ _numDigits + _fpDigits + 1 ];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );
	XmTextFieldSetString ( _field2a, text );
}


void ShapeTemplateCmd::changeField2b ( float value )
{
	char text[ _numDigits + _fpDigits + 1];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );

	XmTextFieldSetString ( _field2b, text );
}


void ShapeTemplateCmd::funct3Callback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd *obj = ( ShapeTemplateCmd * ) clientData;

	char text1[obj->_numDigits+obj->_fpDigits];
	char text2[obj->_numDigits+obj->_fpDigits];
	float value1, value2;

	snprintf ( text1, sizeof ( text1 ), "%s", XmTextFieldGetString ( obj->_field3a ) );
	text1 [ sizeof ( text1 ) - 1 ] = 0;

	if ( strlen ( text1 ) > 0 )
		sscanf ( text1, "%f", &value1 );
	else
	{
		value1 = 0;
		obj->changeField3a ( value1 );
	}
	
	snprintf ( text2, sizeof ( text2 ), "%s", XmTextFieldGetString ( obj->_field3b ) );
	text2 [ sizeof ( text2 ) - 1 ] = 0;

	if ( strlen ( text2 ) > 0 )
		sscanf ( text2, "%f", &value2 );
	else
	{
		value2 = 0;
		obj->changeField3b ( value2 );
	}
	
	obj->funct3 ( value1, value2 );
}


void ShapeTemplateCmd::funct3 ( float start, float end )
{
	if ( _dataType == 0 )
	{
		if ( (*templatePak)[_selectedItemNum-1].graphIntCmd == NULL )
			return;
	}
	else
	{
		if ( (*templatePak)[_selectedItemNum-1].graphFltCmd == NULL )
			return;
	}

	long count;
	float value, scale, increment;

	readData();

	// function body
	increment = ( end - start ) / ( _endData - _startData );
	scale = (*templatePak)[_selectedItemNum-1].max;
	value = start;

	for ( count = _startData; count <= _endData; count ++ )
	{

		if ( _dataType == 0 )	// int
		{
			_idata [ count - _dataOffset ] = ( int ) ( tan ( value ) * scale ) ;
			value += increment;
		}
		else
		{
			_fdata [ count - _dataOffset ] = ( float ) tan ( value );
			value += increment;
		}
	}

	writeData();
}


void ShapeTemplateCmd::field3aEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd* obj = ( ShapeTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field3a ) );
	text [ sizeof ( text ) - 1 ] = 0;
	
	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field3aEntry ( text );
}


void ShapeTemplateCmd::field3bEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd* obj = ( ShapeTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field3b ) );
	text [ sizeof ( text ) - 1 ] = 0;

	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field3bEntry ( text );
}


void ShapeTemplateCmd::field3aEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField3a ( value );
	}
	else
		changeField3a ( 0 );
}


void ShapeTemplateCmd::field3bEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField3b ( value );
	}
	else
		changeField3b ( 0 );
}


void ShapeTemplateCmd::changeField3a ( float value )
{
	char text[ _numDigits + _fpDigits + 1 ];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );
	XmTextFieldSetString ( _field3a, text );
}


void ShapeTemplateCmd::changeField3b ( float value )
{
	char text[ _numDigits + _fpDigits + 1];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );

	XmTextFieldSetString ( _field3b, text );
}


void ShapeTemplateCmd::funct4Callback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd *obj = ( ShapeTemplateCmd * ) clientData;

	char text1[obj->_numDigits+obj->_fpDigits];
	char text2[obj->_numDigits+obj->_fpDigits];
	float value1, value2;

	snprintf ( text1, sizeof ( text1 ), "%s", XmTextFieldGetString ( obj->_field4a ) );
	text1 [ sizeof ( text1 ) - 1 ] = 0;

	if ( strlen ( text1 ) > 0 )
		sscanf ( text1, "%f", &value1 );
	else
	{
		value1 = 0;
		obj->changeField4a ( value1 );
	}
	
	snprintf ( text2, sizeof ( text2 ), "%s", XmTextFieldGetString ( obj->_field4b ) );
	text2 [ sizeof ( text2 ) - 1 ] = 0;

	if ( strlen ( text2 ) > 0 )
		sscanf ( text2, "%f", &value2 );
	else
	{
		value2 = 0;
		obj->changeField4b ( value2 );
	}
	
	obj->funct4 ( value1, value2 );
}


void ShapeTemplateCmd::funct4 ( float start, float end )
{
	if ( _dataType == 0 )
	{
		if ( (*templatePak)[_selectedItemNum-1].graphIntCmd == NULL )
			return;
	}
	else
	{
		if ( (*templatePak)[_selectedItemNum-1].graphFltCmd == NULL )
			return;
	}

	long count;
	float value, scale, increment;

	readData();

	// function body
	increment = ( end - start ) / ( _endData - _startData );
	scale = (*templatePak)[_selectedItemNum-1].max;
	value = start;

	for ( count = _startData; count <= _endData; count ++ )
	{
		if ( _dataType == 0 )	// int
		{
			_idata [ count - _dataOffset ] = ( int ) ( exp ( value ) * scale ) ;
			value += increment;
		}
		else
		{
			_fdata [ count - _dataOffset ] = ( float ) exp ( value );
			value += increment;
		}
	}

	writeData();
}


void ShapeTemplateCmd::field4aEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd* obj = ( ShapeTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field4a ) );
	text [ sizeof ( text ) - 1 ] = 0;
	
	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field4aEntry ( text );
}


void ShapeTemplateCmd::field4bEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd* obj = ( ShapeTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field4b ) );
	text [ sizeof ( text ) - 1 ] = 0;

	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field4bEntry ( text );
}


void ShapeTemplateCmd::field4aEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField4a ( value );
	}
	else
		changeField4a ( 0 );
}


void ShapeTemplateCmd::field4bEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField4b ( value );
	}
	else
		changeField4b ( 0 );
}


void ShapeTemplateCmd::changeField4a ( float value )
{
	char text[ _numDigits + _fpDigits + 1 ];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );
	XmTextFieldSetString ( _field4a, text );
}


void ShapeTemplateCmd::changeField4b ( float value )
{
	char text[ _numDigits + _fpDigits + 1];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );

	XmTextFieldSetString ( _field4b, text );
}


void ShapeTemplateCmd::funct5Callback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd *obj = ( ShapeTemplateCmd * ) clientData;

	char text1[obj->_numDigits+obj->_fpDigits];
	char text2[obj->_numDigits+obj->_fpDigits];
	float value1, value2;

	snprintf ( text1, sizeof ( text1 ), "%s", XmTextFieldGetString ( obj->_field5a ) );
	text1 [ sizeof ( text1 ) - 1 ] = 0;

	if ( strlen ( text1 ) > 0 )
		sscanf ( text1, "%f", &value1 );
	else
	{
		value1 = 1;
		obj->changeField5a ( value1 );
	}
	
	snprintf ( text2, sizeof ( text2 ), "%s", XmTextFieldGetString ( obj->_field5b ) );
	text2 [ sizeof ( text2 ) - 1 ] = 0;

	if ( strlen ( text2 ) > 0 )
		sscanf ( text2, "%f", &value2 );
	else
	{
		value2 = 1;
		obj->changeField5b ( value2 );
	}
	
	obj->funct5 ( value1, value2 );
}


void ShapeTemplateCmd::funct5 ( float start, float end )
{
	if ( _dataType == 0 )
	{
		if ( (*templatePak)[_selectedItemNum-1].graphIntCmd == NULL )
			return;
	}
	else
	{
		if ( (*templatePak)[_selectedItemNum-1].graphFltCmd == NULL )
			return;
	}

	if ( start == 0 )
	{
		changeField5a ( 1 );
		return;
	}
	
	if ( end == 0 )
	{
		changeField5b ( 1 );
		return;
	}

	if ( ( start < 0 ) && ( end > 0 ) )
	{
		char msg[236];
		strncpy ( msg, "Error: range crosses zero: illegal value.\n\
Process this range in separate sections with\nnon-zero bounds.", sizeof ( msg ) );
		msg [ sizeof ( msg ) - 1 ] = 0;
		messageDialogManager->post ( msg );
		return;
	}
	
	long count;
	float value, scale, increment;

	readData();

	// function body
	increment = ( end - start ) / ( _endData - _startData );
	scale = (*templatePak)[_selectedItemNum-1].max;
	value = start;

	for ( count = _startData; count <= _endData; count ++ )
	{

		if ( _dataType == 0 )	// int
		{
			_idata [ count - _dataOffset ] = ( int ) ( log ( value ) * scale ) ;
			value += increment;
		}
		else
		{
			_fdata [ count - _dataOffset ] = ( float ) log ( value );
			value += increment;
		}
	}

	writeData();
}


void ShapeTemplateCmd::field5aEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd* obj = ( ShapeTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field5a ) );
	text [ sizeof ( text ) - 1 ] = 0;
	
	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field5aEntry ( text );
}


void ShapeTemplateCmd::field5bEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd* obj = ( ShapeTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field5b ) );
	text [ sizeof ( text ) - 1 ] = 0;

	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field5bEntry ( text );
}


void ShapeTemplateCmd::field5aEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
	
		if ( value < 0 )
			changeField5a ( 0 );
		else
			changeField5a ( value );
	}
	else
		changeField5a ( 0 );
}


void ShapeTemplateCmd::field5bEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		
		if ( value < 0 )
			changeField5b ( 0 );
		else
			changeField5b ( value );
	}
	else
		changeField5b ( 0 );
}


void ShapeTemplateCmd::changeField5a ( float value )
{	
	char text[ _numDigits + _fpDigits + 1 ];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );
	XmTextFieldSetString ( _field5a, text );
}


void ShapeTemplateCmd::changeField5b ( float value )
{
	char text[ _numDigits + _fpDigits + 1];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );

	XmTextFieldSetString ( _field5b, text );
}


void ShapeTemplateCmd::funct6Callback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd *obj = ( ShapeTemplateCmd * ) clientData;

	char text1[obj->_numDigits+obj->_fpDigits];
	char text2[obj->_numDigits+obj->_fpDigits];
	unsigned int value1;
	float value2;

	snprintf ( text1, sizeof ( text1 ), "%s", XmTextFieldGetString ( obj->_field6a ) );
	text1 [ sizeof ( text1 ) - 1 ] = 0;

	if ( strlen ( text1 ) > 0 )
		sscanf ( text1, "%u", &value1 );
	else
	{
		value1 = 1;
		obj->changeField6a ( value1 );
	}

	snprintf ( text2, sizeof ( text2 ), "%s", XmTextFieldGetString ( obj->_field6b ) );
	text2 [ sizeof ( text2 ) - 1 ] = 0;

	if ( strlen ( text2 ) > 0 )
		sscanf ( text2, "%f", &value2 );
	else
	{
		value2 = 2;
		obj->changeField6b ( value2 );
	}

	obj->funct6 ( value1, value2 );
}


void ShapeTemplateCmd::funct6 ( unsigned int numPoints, float weighting )
{
	if ( _dataType == 0 )
	{
		if ( (*templatePak)[_selectedItemNum-1].graphIntCmd == NULL )	// we don't deal with int arrays for spatial
							// templates, they're all f.p.
			return;

		readData();
		
		// separate BreakCmd instance for this lengthy op
		DataConformCmd *dataConform = new DataConformCmd ( "dataConform", TRUE,
													NULL, _idata, _startData, _endData,
													numPoints, weighting, _dataType, ( char * ) _name );

		dataConform->execute ( &ShapeTemplateCmd::dataConformFinishedCallback, ( void * ) this );
	}
	else
	{
		if ( (*templatePak)[_selectedItemNum-1].graphFltCmd == NULL )
			return;

		readData();

		// separate BreakCmd instance for this lengthy op
		DataConformCmd *dataConform = new DataConformCmd ( "dataConform", TRUE,
													_fdata, NULL, _startData, _endData,
													numPoints, weighting, _dataType, ( char * ) _name );
		
		dataConform->execute ( &ShapeTemplateCmd::dataConformFinishedCallback, ( void * ) this );
	}
}


void ShapeTemplateCmd::dataConformFinishedCallback ( BreakCmd *cmd, Boolean interrupted, void *clientData )
{
	DataConformCmd *dcObj = ( DataConformCmd * ) cmd;
	ShapeTemplateCmd *obj = ( ShapeTemplateCmd * ) clientData;

	if ( interrupted )
		infoDialogManager->post ( "Interrupted!" );
	else                               
		obj->dataConformFinished ( dcObj );

//obj->setNormalCursor();
	delete dcObj;
}


void ShapeTemplateCmd::dataConformFinished ( DataConformCmd *dcObj )
{
	if ( dcObj->error() != 0 )
	{
		char msg [ strlen ( _name ) + 256 ];
		snprintf ( msg, sizeof ( msg ), "%s\nDataConformCmd error: ", _name );
		msg [ sizeof ( msg ) - 1 ]  = 0;
		
		if ( dcObj->error() == 1 )
			strncat ( msg, "name too long for allocated space.", sizeof ( msg ) );

		if ( dcObj->error() == 2 )
			strncat ( msg, "less than requested items written to file.", sizeof ( msg ) );

		if ( dcObj->error() == 3 )
			strncat ( msg, "less than requested items read from file.", sizeof ( msg ) );

		msg [ sizeof ( msg ) - 1 ] = 0;
		messageDialogManager->post ( msg );
	}
	else
		writeData();
}


void ShapeTemplateCmd::field6aEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd* obj = ( ShapeTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field6a ) );
	text [ sizeof ( text ) - 1 ] = 0;
	
	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "1", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field6aEntry ( text );
}


void ShapeTemplateCmd::field6aEntry ( char *text )
{
	unsigned int value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%u", &value );
		changeField6a ( value );
	}
	else
		changeField6a ( 1 );
}


void ShapeTemplateCmd::changeField6a ( unsigned int value )
{	
	if ( value > ( unsigned int ) ( _endData - _startData - 1 ) )
		value = ( unsigned int ) _endData - _startData - 1;
			
	char text[ _numDigits + 1 ];
	snprintf ( text, sizeof ( text ), "%u", value );
	text [ sizeof ( text ) - 1 ] = 0;
	XmTextFieldSetString ( _field6a, text );
}


void ShapeTemplateCmd::field6bEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeTemplateCmd* obj = ( ShapeTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field6b ) );
	text [ sizeof ( text ) - 1 ] = 0;

	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "2", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field6bEntry ( text );
}


void ShapeTemplateCmd::field6bEntry ( char *text )
{
	float value;

	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f", &value );

		if ( value < 0 )
			value *= -1;	// don't invert the view, might confuse the user

		changeField6b ( value );
	}
	else
		changeField6b ( 2 );
}


void ShapeTemplateCmd::changeField6b ( float value )
{
	char text[ _numDigits + 1 ];
	snprintf ( text, sizeof ( text ), "%f", value );
	text [ sizeof ( text ) - 1 ] = 0;
	XmTextFieldSetString ( _field6b, text );
}


int ShapeTemplateCmd::checkTextEntry ( char *text )
{
	int error = 0;
	int length = strlen ( text );
	char c = 0;

	for ( int count = 0; count < length; count++ )
	{
		c = text [ count ];

		if ( ( c < '0' ) || ( c > '9' ) )
		{
			if (  c == '.' )
				error = 0;
			else
			{
				if ( ( c == '-' ) && ( count == 0 ) )
					error = 0;
				else
				{
					char msg[26];
					sprintf ( msg, "Error: '%c' non-numeric.", c );
					messageDialogManager->post( msg );
					error = 1;
				}
			}
		}
	}

	if ( error )
	{
		// assume invalid, pop up format msg
		char msg[BUFSIZE];
		snprintf ( msg, sizeof ( msg ), "Invalid format %s",  text );
		msg [ sizeof ( msg ) - 1 ] = 0;
		messageDialogManager->post ( msg );
	}
	
	return error;
}


void ShapeTemplateCmd::readData()
{
	switch ( _dataType )
	{
		case 0:	// int
				if ( (*templatePak)[_selectedItemNum-1].graphIntCmd != NULL )
				{
					_idata = (*templatePak)[_selectedItemNum-1].pIntArray;
					_startData = (*templatePak)[_selectedItemNum-1].startSel;
					_endData = (*templatePak)[_selectedItemNum-1].endSel;

					if ( ( _startData < (*templatePak)[_selectedItemNum-1].startRange ) ||
						( _endData > (*templatePak)[_selectedItemNum-1].endSel ) )
					{
						// print msg, 'selection not in view, use zoom in to view seln
						char msg[BUFSIZE];
				
						snprintf ( msg, sizeof ( msg ), "%s\nSelection not in view; use 'Zoom in'\nin \
template view.", (*templatePak)[_selectedItemNum-1].name );
						// keep the values anyway
						msg [ sizeof ( msg ) - 1 ] = 0;
						messageDialogManager->post ( msg );
					}
				}
				else
					return;

			break;
			
		case 1:	// float
				if ( (*templatePak)[_selectedItemNum-1].graphFltCmd != NULL )
				{
					_fdata = (*templatePak)[_selectedItemNum-1].pFloatArray;
					_startData = (*templatePak)[_selectedItemNum-1].startSel;
					_endData = (*templatePak)[_selectedItemNum-1].endSel;

					if ( ( _startData < (*templatePak)[_selectedItemNum-1].startRange ) ||
						( _endData > (*templatePak)[_selectedItemNum-1].endSel ) )
					{
						// print msg, 'selection not in view, use zoom in to view seln
						char msg[BUFSIZE];
				
						snprintf ( msg, sizeof ( msg ), "%s\nSelection not in view; use 'Zoom in'\nin \
template view.", (*templatePak)[_selectedItemNum-1].name );
						// keep the values anyway
						msg [ sizeof ( msg ) - 1 ] = 0;
						messageDialogManager->post ( msg );
					}
				}
				else
					return;
			
			break;
	}
	
	if ( _dataType == 0 )	// int
		_dataOffset = (*templatePak)[_selectedItemNum-1].graphIntCmd->startData();
	else
		_dataOffset = (*templatePak)[_selectedItemNum-1].graphFltCmd->startData();

	if ( _startData == _endData )
	{
		char msg[BUFSIZE];
		
		snprintf ( msg, sizeof ( msg ), "%s\nNo selection, execute failed.",
					(*templatePak)[_selectedItemNum-1].name	);
		
		msg [ sizeof ( msg ) - 1 ] = 0;
		messageDialogManager->post ( msg );
		return;
	}
}


void ShapeTemplateCmd::writeData()
{
		(*templatePak)[_selectedItemNum-1].templateChanged = 1;

		if ( _dataType == 0 )
			(*templatePak)[_selectedItemNum-1].graphIntCmd->redisplay (
							(*templatePak)[_selectedItemNum-1].startRange,
							(*templatePak)[_selectedItemNum-1].endRange,
							(*templatePak)[_selectedItemNum-1].startSel,
							(*templatePak)[_selectedItemNum-1].endSel,
							(*templatePak)[_selectedItemNum-1].xCurrent,
							_dataOffset );
		else
			(*templatePak)[_selectedItemNum-1].graphFltCmd->redisplay (
							(*templatePak)[_selectedItemNum-1].startRange,
							(*templatePak)[_selectedItemNum-1].endRange,
							(*templatePak)[_selectedItemNum-1].startSel,
							(*templatePak)[_selectedItemNum-1].endSel,
							(*templatePak)[_selectedItemNum-1].xCurrent,
							_dataOffset );
}

