/*
 UndoCmd.h - interface for undoing the last Cmd

 Douglas A. Young, 'Object-oriented Programming with C++ and OSF/Motif'
 2nd ed., Prentice-Hall.
*/

#ifndef UNDOCMD_H
#define UNDOCMD_H

#include "NoUndoCmd.h"

class UndoCmd : public NoUndoCmd
{
	public:
		UndoCmd ( const char * );
	
	protected:
		virtual void doCommand();
};

extern UndoCmd *backtrack;

#endif

/*
  Notes:
  
  When a Cmd is executed, the object (de)activates a central Cmd object
  'undoCmd', depending on whether the exec'd obj supports undo. This obj, an
  instance of UndoCmd (whose sole function is call the undo() method for the
  most recently exec'd Cmd obj), cannot be undone, so UndoCmd is derived
  from NoUndoCmd.
  
  The Application Framework contains only asingle instance of UndoCmd,
  available by inclusion of 'UndoCmd.h'.
*/
